diff --git a/src/backend/libpq/be-secure-openssl.c b/src/backend/libpq/be-secure-openssl.c
index 4ce2a92b964..ce185428ad4 100644
--- a/src/backend/libpq/be-secure-openssl.c
+++ b/src/backend/libpq/be-secure-openssl.c
@@ -100,9 +100,7 @@ static const char *SSLerrmessageExt(unsigned long ecode, const char *replacement
 static const char *SSLerrmessage(unsigned long ecode);
 static bool init_host_context(HostsLine *host, bool isServerStart);
 static void host_context_cleanup_cb(void *arg);
-#ifdef HAVE_SSL_CTX_SET_CLIENT_HELLO_CB
 static int	sni_clienthello_cb(SSL *ssl, int *al, void *arg);
-#endif
 
 static char *X509_NAME_to_cstring(const X509_NAME *name);
 
@@ -204,17 +202,6 @@ be_tls_init(bool isServerStart)
 	 */
 	if (ssl_sni)
 	{
-		/*
-		 * The GUC check hook should have already blocked this but to be on
-		 * the safe side we double-check here.
-		 */
-#ifndef HAVE_SSL_CTX_SET_CLIENT_HELLO_CB
-		ereport(isServerStart ? FATAL : LOG,
-				errcode(ERRCODE_CONFIG_FILE_ERROR),
-				errmsg("ssl_sni is not supported with LibreSSL"));
-		goto error;
-#endif
-
 		/* Attempt to load configuration from pg_hosts.conf */
 		res = load_hosts(&pg_hosts, &err_msg);
 
@@ -369,8 +356,6 @@ be_tls_init(bool isServerStart)
 		goto error;
 	}
 
-#ifdef HAVE_SSL_CTX_SET_CLIENT_HELLO_CB
-
 	/*
 	 * Create a new SSL context into which we'll load all the configuration
 	 * settings.  If we fail partway through, we can avoid memory leakage by
@@ -389,22 +374,6 @@ be_tls_init(bool isServerStart)
 						SSLerrmessage(ERR_get_error()))));
 		goto error;
 	}
-#else
-
-	/*
-	 * If the client hello callback isn't supported we want to use the default
-	 * context as the one to drive the handshake so avoid creating a new one
-	 * and use the already existing default one instead.
-	 */
-	context = new_hosts->default_host->ssl_ctx;
-
-	/*
-	 * Since we don't allocate a new SSL_CTX here like we do when SNI has been
-	 * enabled we need to bump the reference count on context to avoid double
-	 * free of the context when using the same cleanup logic across the cases.
-	 */
-	SSL_CTX_up_ref(context);
-#endif
 
 	/*
 	 * Disable OpenSSL's moving-write-buffer sanity check, because it causes
@@ -481,15 +450,10 @@ be_tls_init(bool isServerStart)
 	/*
 	 * Disallow SSL session tickets. OpenSSL use both stateful and stateless
 	 * tickets for TLSv1.3, and stateless ticket for TLSv1.2. SSL_OP_NO_TICKET
-	 * is available since 0.9.8f but only turns off stateless tickets. In
-	 * order to turn off stateful tickets we need SSL_CTX_set_num_tickets,
-	 * which is available since OpenSSL 1.1.1.  LibreSSL 3.5.4 (from OpenBSD
-	 * 7.1) introduced this API for compatibility, but doesn't support session
-	 * tickets at all so it's a no-op there.
+	 * only turns off stateless tickets, In order to turn off stateful tickets
+	 * we need SSL_CTX_set_num_tickets.
 	 */
-#ifdef HAVE_SSL_CTX_SET_NUM_TICKETS
 	SSL_CTX_set_num_tickets(context, 0);
-#endif
 	SSL_CTX_set_options(context, SSL_OP_NO_TICKET);
 
 	/* disallow SSL session caching, too */
@@ -501,17 +465,8 @@ be_tls_init(bool isServerStart)
 	/*
 	 * Disallow SSL renegotiation.  This concerns only TLSv1.2 and older
 	 * protocol versions, as TLSv1.3 has no support for renegotiation.
-	 * SSL_OP_NO_RENEGOTIATION is available in OpenSSL since 1.1.0h (via a
-	 * backport from 1.1.1). SSL_OP_NO_CLIENT_RENEGOTIATION is available in
-	 * LibreSSL since 2.5.1 disallowing all client-initiated renegotiation
-	 * (this is usually on by default).
 	 */
-#ifdef SSL_OP_NO_RENEGOTIATION
 	SSL_CTX_set_options(context, SSL_OP_NO_RENEGOTIATION);
-#endif
-#ifdef SSL_OP_NO_CLIENT_RENEGOTIATION
-	SSL_CTX_set_options(context, SSL_OP_NO_CLIENT_RENEGOTIATION);
-#endif
 
 	/* set up ephemeral DH and ECDH keys */
 	if (!initialize_dh(context, isServerStart))
@@ -873,36 +828,14 @@ be_tls_open_server(Port *port)
 	}
 
 	/*
-	 * If the underlying TLS library supports the client hello callback we use
-	 * that in order to support host based configuration using the SNI TLS
-	 * extension.  If the user has disabled SNI via the ssl_sni GUC we still
-	 * make use of the callback in order to have consistent handling of
-	 * OpenSSL contexts, except in that case the callback will install the
-	 * default configuration regardless of the hostname sent by the user in
-	 * the handshake.
-	 *
-	 * In case the TLS library does not support the client hello callback, as
-	 * of this writing LibreSSL does not, we need to install the client cert
-	 * verification callback here (if the user configured a CA) since we
-	 * cannot use the OpenSSL context update functionality.
+	 * We use tje clienthello callback in order to support host based
+	 * configuration using the SNI TLS extension.  If the user has disabled SNI
+	 * via the ssl_sni GUC we still make use of the callback in order to have
+	 * consistent handling of OpenSSL contexts, except in that case the
+	 * callback will install the default configuration regardless of the
+	 * hostname sent by the user in the handshake.
 	 */
-#ifdef HAVE_SSL_CTX_SET_CLIENT_HELLO_CB
 	SSL_CTX_set_client_hello_cb(SSL_context, sni_clienthello_cb, NULL);
-#else
-	if (SSL_hosts->default_host->ssl_ca && SSL_hosts->default_host->ssl_ca[0])
-	{
-		/*
-		 * Always ask for SSL client cert, but don't fail if it's not
-		 * presented.  We might fail such connections later, depending on what
-		 * we find in pg_hba.conf.
-		 */
-		SSL_set_verify(port->ssl,
-					   (SSL_VERIFY_PEER | SSL_VERIFY_CLIENT_ONCE),
-					   verify_cb);
-
-		ssl_loaded_verify_locations = true;
-	}
-#endif
 
 	err_context.cert_errdetail = NULL;
 	SSL_set_ex_data(port->ssl, 0, &err_context);
@@ -990,12 +923,8 @@ aloop:
 					case SSL_R_WRONG_SSL_VERSION:
 					case SSL_R_WRONG_VERSION_NUMBER:
 					case SSL_R_TLSV1_ALERT_PROTOCOL_VERSION:
-#ifdef SSL_R_VERSION_TOO_HIGH
 					case SSL_R_VERSION_TOO_HIGH:
-#endif
-#ifdef SSL_R_VERSION_TOO_LOW
 					case SSL_R_VERSION_TOO_LOW:
-#endif
 						give_proto_hint = true;
 						break;
 					default:
@@ -1810,7 +1739,6 @@ alpn_cb(SSL *ssl,
 	}
 }
 
-#ifdef HAVE_SSL_CTX_SET_CLIENT_HELLO_CB
 /*
  * ssl_update_ssl
  *
@@ -2057,7 +1985,6 @@ found:
 
 	return SSL_CLIENT_HELLO_SUCCESS;
 }
-#endif							/* HAVE_SSL_CTX_SET_CLIENT_HELLO_CB */
 
 /*
  * Set DH parameters for generating ephemeral DH keys.  The
@@ -2282,15 +2209,9 @@ be_tls_get_certificate_hash(Port *port, size_t *len)
 
 	/*
 	 * Get the signature algorithm of the certificate to determine the hash
-	 * algorithm to use for the result.  Prefer X509_get_signature_info(),
-	 * introduced in OpenSSL 1.1.1, which can handle RSA-PSS signatures.
+	 * algorithm to use for the result.
 	 */
-#if HAVE_X509_GET_SIGNATURE_INFO
 	if (!X509_get_signature_info(server_cert, &algo_nid, NULL, NULL, NULL))
-#else
-	if (!OBJ_find_sigid_algs(X509_get_signature_nid(server_cert),
-							 &algo_nid, NULL))
-#endif
 		elog(ERROR, "could not determine server certificate signature algorithm");
 
 	/*
diff --git a/src/backend/libpq/meson.build b/src/backend/libpq/meson.build
index 8571f652844..d835d356335 100644
--- a/src/backend/libpq/meson.build
+++ b/src/backend/libpq/meson.build
@@ -18,7 +18,11 @@ backend_sources += files(
 )
 
 if ssl.found()
-  backend_sources += files('be-secure-openssl.c')
+  if ssl_library == 'openssl'
+    backend_sources += files('be-secure-openssl.c')
+  else
+    backend_sources += files('be-secure-libressl.c')
+  endif
 endif
 
 if gssapi.found()
diff --git a/src/include/common/openssl.h b/src/include/common/openssl.h
index 07e8bfbe4f0..c253ebe5e72 100644
--- a/src/include/common/openssl.h
+++ b/src/include/common/openssl.h
@@ -14,7 +14,7 @@
 #ifndef COMMON_OPENSSL_H
 #define COMMON_OPENSSL_H
 
-#ifdef USE_OPENSSL
+#if defined(USE_OPENSSL) || defined(USE_LIBRESSL)
 #include <openssl/ssl.h>
 
 /*
@@ -38,6 +38,6 @@
 #define MAX_OPENSSL_TLS_VERSION  "TLSv1"
 #endif
 
-#endif							/* USE_OPENSSL */
+#endif							/* USE_OPENSSL, USE_LIBRESSL */
 
 #endif							/* COMMON_OPENSSL_H */
diff --git a/src/include/libpq/libpq-be.h b/src/include/libpq/libpq-be.h
index 921b2daa4ff..71925270690 100644
--- a/src/include/libpq/libpq-be.h
+++ b/src/include/libpq/libpq-be.h
@@ -21,7 +21,7 @@
 #include "common/scram-common.h"
 
 #include <sys/time.h>
-#ifdef USE_OPENSSL
+#if defined(USE_OPENSSL) || defined(USE_LIBRESSL)
 #include <openssl/ssl.h>
 #include <openssl/err.h>
 #endif
@@ -218,7 +218,7 @@ typedef struct Port
 	 * (Although extensions should have no business accessing the raw_buf
 	 * fields anyway.)
 	 */
-#ifdef USE_OPENSSL
+#if defined(USE_OPENSSL) || defined(USE_LIBRESSL)
 	SSL		   *ssl;
 	X509	   *peer;
 #else
@@ -331,12 +331,12 @@ extern void be_tls_get_peer_serial(Port *port, char *ptr, size_t len);
 extern char *be_tls_get_certificate_hash(Port *port, size_t *len);
 
 /* init hook for SSL, the default sets the password callback if appropriate */
-#ifdef USE_OPENSSL
+#if defined(USE_OPENSSL) || defined(USE_LIBRESSL)
 typedef void (*openssl_tls_init_hook_typ) (SSL_CTX *context, bool isServerStart);
 extern PGDLLIMPORT openssl_tls_init_hook_typ openssl_tls_init_hook;
 #endif
 
-#endif							/* USE_SSL */
+#endif							/* USE_SSL, USE_LIBRESSL */
 
 #ifdef ENABLE_GSS
 /*
diff --git a/src/include/libpq/libpq.h b/src/include/libpq/libpq.h
index d15073a0a93..05d80831715 100644
--- a/src/include/libpq/libpq.h
+++ b/src/include/libpq/libpq.h
@@ -123,12 +123,16 @@ extern PGDLLIMPORT bool ssl_loaded_verify_locations;
 #endif
 
 #ifdef USE_SSL
+#if defined(USE_OPENSSL)
 #define SSL_LIBRARY "OpenSSL"
+#elif defined(USE_LIBRESSL)
+#define SSL_LIBRARY "LibreSSL"
 #else
 #define SSL_LIBRARY ""
 #endif
+#endif
 
-#ifdef USE_OPENSSL
+#ifdef USE_SSL
 #define DEFAULT_SSL_CIPHERS "HIGH:MEDIUM:+3DES:!aNULL"
 #else
 #define DEFAULT_SSL_CIPHERS "none"
diff --git a/src/include/pg_config.h.in b/src/include/pg_config.h.in
index 4f8113c144b..4bfab619a61 100644
--- a/src/include/pg_config.h.in
+++ b/src/include/pg_config.h.in
@@ -369,20 +369,12 @@
 /* Define to 1 if the system has the type `socklen_t'. */
 #undef HAVE_SOCKLEN_T
 
-/* Define to 1 if you have the `SSL_CTX_set_cert_cb' function. */
-#undef HAVE_SSL_CTX_SET_CERT_CB
-
 /* Define to 1 if you have the `SSL_CTX_set_ciphersuites' function. */
 #undef HAVE_SSL_CTX_SET_CIPHERSUITES
 
-/* Define to 1 if you have the `SSL_CTX_set_client_hello_cb' function. */
-#undef HAVE_SSL_CTX_SET_CLIENT_HELLO_CB
-
-/* Define to 1 if you have the `SSL_CTX_set_keylog_callback' function. */
-#undef HAVE_SSL_CTX_SET_KEYLOG_CALLBACK
-
-/* Define to 1 if you have the `SSL_CTX_set_num_tickets' function. */
-#undef HAVE_SSL_CTX_SET_NUM_TICKETS
+/* Define to 1 if you have the `SSL_CTX_use_certificate_chain_mem' function.
+   */
+#undef HAVE_SSL_CTX_USE_CERTIFICATE_CHAIN_MEM
 
 /* Define to 1 if you have the <stdint.h> header file. */
 #undef HAVE_STDINT_H
@@ -508,9 +500,6 @@
 /* Define to 1 if you have the `wcstombs_l' function. */
 #undef HAVE_WCSTOMBS_L
 
-/* Define to 1 if you have the `X509_get_signature_info' function. */
-#undef HAVE_X509_GET_SIGNATURE_INFO
-
 /* Define to 1 if the assembler supports X86_64's POPCNTQ instruction. */
 #undef HAVE_X86_64_POPCNTQ
 
@@ -707,6 +696,9 @@
 /* Define to build with NUMA support. (--with-libnuma) */
 #undef USE_LIBNUMA
 
+/* Define to 1 to build with LibreSSL support. (--with-ssl=libressl) */
+#undef USE_LIBRESSL
+
 /* Define to build with io_uring support. (--with-liburing) */
 #undef USE_LIBURING
 
diff --git a/src/include/pg_config_manual.h b/src/include/pg_config_manual.h
index 521b49b8888..e01fee2a9af 100644
--- a/src/include/pg_config_manual.h
+++ b/src/include/pg_config_manual.h
@@ -173,7 +173,7 @@
  * USE_SSL code should be compiled only when compiling with an SSL
  * implementation.
  */
-#ifdef USE_OPENSSL
+#if defined(USE_OPENSSL) || defined(USE_LIBRESSL)
 #define USE_SSL
 #endif
 
diff --git a/src/interfaces/libpq/Makefile b/src/interfaces/libpq/Makefile
index 0963995eed4..ac925319bc6 100644
--- a/src/interfaces/libpq/Makefile
+++ b/src/interfaces/libpq/Makefile
@@ -56,6 +56,10 @@ ifeq ($(with_ssl),openssl)
 OBJS += \
 	fe-secure-openssl.o
 endif
+ifeq ($(with_ssl),libressl)
+OBJS += \
+	fe-secure-libressl.o
+endif
 
 ifeq ($(with_gssapi),yes)
 OBJS += \
